## adapterremoval 2.3.3

=== Makefile ===
###############################################################################
# Makefile options: Edit / comment / uncomment to change build behavior
#

# Installation destinations
PREFIX := /usr/local

# Default compilation flags
CXXFLAGS := ${CXXFLAGS} -std=c++11 -O3

## Optional features; comment out or set to value other than 'yes' to disable

# Hide individual commands during build; only shows summaries instead.
QUIET_BUILD := yes

# Use of colored output during build
COLOR_BUILD := yes

# Debug build; adds warnings and debugging symbols
DEBUG_BUILD := no

# Include coverage instrumentation in build
COVERAGE := no

###############################################################################
# Makefile internals. Normally you do not need to touch these.

INSTALLEXE = install -m 0755
INSTALLDAT = install -m 0644
INSTALLDOC = install -m 0644
MKDIR      = install -d  # act as mkdir -p

# Libraries required by AdapterRemoval
LIBRARIES := -pthread -lz -lbz2

# Build directory; modified depending on build options
BDIR     := build/main


ifeq ($(strip ${QUIET_BUILD}),yes)
QUIET := @
endif

ifeq ($(strip ${COLOR_BUILD}),yes)
COLOR_YELLOW := "\033[0;33m"
COLOR_GREEN := "\033[0;32m"
COLOR_CYAN := "\033[0;36m"
COLOR_END := "\033[0m"
endif

ifeq ($(strip ${COVERAGE}), yes)
$(info Building AdapterRemoval with coverage instrumentation: yes)
CXXFLAGS := ${CXXFLAGS} --coverage
DEBUG_BUILD := yes
else
$(info Building AdapterRemoval with coverage instrumentation: no)
endif

ifeq ($(strip ${DEBUG_BUILD}), yes)
$(info Building AdapterRemoval with debug information: yes)
CXXFLAGS := ${CXXFLAGS} -g -pedantic -Wall -Wextra -Wcast-align -Wcast-qual \
	-Wctor-dtor-privacy -Wdisabled-optimization -Wformat=2 -Winit-self \
	-Wold-style-cast -Woverloaded-virtual -Wredundant-decls -Wsign-promo \
	-Wstrict-overflow=2 -Wswitch-default -Wundef -Weffc++ -Wdeprecated
else
$(info Building AdapterRemoval with debug information: no)
endif

PROG     := AdapterRemoval
LIBNAME  := libadapterremoval
LIBOBJS  := $(BDIR)/adapterset.o \
            $(BDIR)/alignment.o \
            $(BDIR)/alignment_tables.o \
            $(BDIR)/argparse.o \
            $(BDIR)/barcode_table.o \
            $(BDIR)/debug.o \
            $(BDIR)/demultiplex.o \
            $(BDIR)/fastq.o \
            $(BDIR)/fastq_enc.o \
            $(BDIR)/fastq_io.o \
            $(BDIR)/linereader.o \
            $(BDIR)/linereader_joined.o \
            $(BDIR)/main_adapter_id.o \
            $(BDIR)/main_adapter_rm.o \
            $(BDIR)/main_demultiplex.o \
            $(BDIR)/managed_writer.o \
            $(BDIR)/scheduler.o \
            $(BDIR)/strutils.o \
            $(BDIR)/threads.o \
            $(BDIR)/timer.o \
            $(BDIR)/trimmed_reads.o \
            $(BDIR)/userconfig.o
OBJS     := ${LIBOBJS} $(BDIR)/main.o
DFILES   := $(OBJS:.o=.deps)


.PHONY: all install clean test clean_tests static regression docs

all: build/$(PROG)

everything: all static test regression docs

# Clean
clean: clean_tests clean_docs
	@echo $(COLOR_GREEN)"Cleaning ..."$(COLOR_END)
	$(QUIET) rm -f build/$(PROG) build/$(LIBNAME).a
	$(QUIET) rm -rvf build/regression
	$(QUIET) rm -rvf $(BDIR)

# Install
install: build/$(PROG)
	@echo $(COLOR_GREEN)"Installing AdapterRemoval .."$(COLOR_END)
	@echo $(COLOR_GREEN)"  .. binary into ${PREFIX}/bin/"$(COLOR_END)
	$(QUIET) $(MKDIR) ${PREFIX}/bin/
	$(QUIET) $(INSTALLEXE) build/$(PROG) ${PREFIX}/bin/

	@echo $(COLOR_GREEN)"  .. man-page into ${PREFIX}/share/man/man1/"$(COLOR_END)
	$(QUIET) $(MKDIR) ${PREFIX}/share/man/man1/
	$(QUIET) $(INSTALLDOC) $(PROG).1 ${PREFIX}/share/man/man1/

	@echo $(COLOR_GREEN)"  .. README into ${PREFIX}/share/adapterremoval/"$(COLOR_END)
	$(QUIET) $(MKDIR) ${PREFIX}/share/adapterremoval/
	$(QUIET) $(INSTALLDOC) README.md ${PREFIX}/share/adapterremoval/

	@echo $(COLOR_GREEN)"  .. examples into ${PREFIX}/share/adapterremoval/examples/"$(COLOR_END)
	$(QUIET) $(MKDIR) ${PREFIX}/share/adapterremoval/examples/
	$(QUIET) $(INSTALLDAT) examples/*.* ${PREFIX}/share/adapterremoval/examples/

static: build/$(LIBNAME).a

# Object files
$(BDIR)/%.o: src/%.cpp
	@echo $(COLOR_CYAN)"Building $@ from $<"$(COLOR_END)
	$(QUIET) $(MKDIR) $(BDIR)
	$(QUIET) $(CXX) $(CXXFLAGS) -pthread -c -o $@ $<
	$(QUIET) $(CXX) $(CXXFLAGS) -w -MM -MT $@ -MF $(@:.o=.deps) $<

# Executable
build/$(PROG): $(OBJS)
	@echo $(COLOR_GREEN)"Linking executable $@"$(COLOR_END)
	$(QUIET) $(CXX) $(CXXFLAGS) ${LDFLAGS} $^ ${LIBRARIES} -o $@

# Static library
build/$(LIBNAME).a: $(LIBOBJS)
	@echo $(COLOR_GREEN)"Linking static library $@"$(COLOR_END)
	$(AR) rcs build/$(LIBNAME).a $(LIBOBJS)

# Automatic header depencencies
-include $(DFILES)


#
# Unit testing
#
TEST_DIR := build/tests
TEST_OBJS := $(TEST_DIR)/main_test.o \
             $(TEST_DIR)/debug.o \
             $(TEST_DIR)/alignment.o \
             $(TEST_DIR)/alignment_tables.o \
             $(TEST_DIR)/alignment_test.o \
             $(TEST_DIR)/argparse.o \
             $(TEST_DIR)/argparse_test.o \
             $(TEST_DIR)/barcodes_test.o \
             $(TEST_DIR)/barcode_table.o \
             $(TEST_DIR)/fastq.o \
             $(TEST_DIR)/fastq_test.o \
             $(TEST_DIR)/fastq_enc.o \
             $(TEST_DIR)/fastq_enc_test.o \
             $(TEST_DIR)/strutils.o \
             $(TEST_DIR)/strutils_test.o
TEST_DEPS := $(TEST_OBJS:.o=.deps)

TEST_CXXFLAGS := -Isrc -DAR_TEST_BUILD -g

test: $(TEST_DIR)/main
	@echo $(COLOR_GREEN)"Running unit tests"$(COLOR_END)
	$(QUIET) $(TEST_DIR)/main

clean_tests:
	@echo $(COLOR_GREEN)"Cleaning tests ..."$(COLOR_END)
	$(QUIET) rm -rvf $(TEST_DIR)

$(TEST_DIR)/main: $(TEST_OBJS)
	@echo $(COLOR_GREEN)"Linking executable $@"$(COLOR_END)
	$(QUIET) $(CXX) $(CXXFLAGS) ${LIBRARIES} $^ -o $@

$(TEST_DIR)/%.o: tests/unit/%.cpp
	@echo $(COLOR_CYAN)"Building $@ from $<"$(COLOR_END)
	$(QUIET) $(MKDIR) $(TEST_DIR)
	$(QUIET) $(CXX) $(CXXFLAGS) $(TEST_CXXFLAGS) -c -o $@ $<
	$(QUIET) $(CXX) $(CXXFLAGS) $(TEST_CXXFLAGS) -w -MM -MT $@ -MF $(@:.o=.deps) $<

$(TEST_DIR)/%.o: src/%.cpp
	@echo $(COLOR_CYAN)"Building $@ from $<"$(COLOR_END)
	$(QUIET) $(MKDIR) $(TEST_DIR)
	$(QUIET) $(CXX) $(CXXFLAGS) $(TEST_CXXFLAGS) -c -o $@ $<
	$(QUIET) $(CXX) $(CXXFLAGS) $(TEST_CXXFLAGS) -w -MM -MT $@ -MF $(@:.o=.deps) $<


#
# Validation
#
VALIDATION_BDIR=./build/regression
VALIDATION_SDIR=./tests/regression

regression: build/$(PROG)
	@echo $(COLOR_GREEN)"Running regression tests"$(COLOR_END)
	@$(MKDIR) $(VALIDATION_BDIR)
	@$(VALIDATION_SDIR)/run $(VALIDATION_BDIR) $(VALIDATION_SDIR)


# Automatic header dependencies for tests
-include $(TEST_DEPS)


#
# Documentation
#
SPHINXOPTS  = -n -q
SPHINXBUILD = sphinx-build

docs:
	$(QUIET) @$(SPHINXBUILD) -M html docs build/docs $(SPHINXOPTS)
	$(QUIET) @$(SPHINXBUILD) -M man docs build/docs $(SPHINXOPTS)
	$(QUIET) cp -v "build/docs/man/AdapterRemoval.1" .

clean_docs:
	@echo $(COLOR_GREEN)"Cleaning documentation ..."$(COLOR_END)
	$(QUIET) rm -rvf build/docs

=== debian/changelog ===
adapterremoval (2.3.3-2) unstable; urgency=medium

  * Fix watch file
  * Standards-Version: 4.6.1 (routine-update)

 -- Andreas Tille <tille@debian.org>  Sat, 26 Nov 2022 07:50:58 +0100

adapterremoval (2.3.3-1) unstable; urgency=medium

  * No patches needed in new upstream version any more
  * New upstream version

 -- Andreas Tille <tille@debian.org>  Fri, 15 Apr 2022 15:44:21 +0200

adapterremoval (2.3.2-2) unstable; urgency=medium

  [ Steve Langasek ]
  * Import catch2 version 2.13.8 to fix build failure with glibc 2.34
    Closes: #1009616

 -- Andreas Tille <tille@debian.org>  Wed, 13 Apr 2022 11:23:03 +0200

=== debian/control ===
Source: adapterremoval
Maintainer: Debian Med Packaging Team <debian-med-packaging@lists.alioth.debian.org>
Uploaders: Andreas Tille <tille@debian.org>,
           Kevin Murray <kdmfoss@gmail.com>
Section: science
Priority: optional
Build-Depends: debhelper-compat (= 13),
               zlib1g-dev,
               libbz2-dev,
               libgtest-dev,
               markdown
Standards-Version: 4.6.1
Vcs-Browser: https://salsa.debian.org/med-team/adapterremoval
Vcs-Git: https://salsa.debian.org/med-team/adapterremoval.git
Homepage: https://github.com/MikkelSchubert/adapterremoval
Rules-Requires-Root: no

Package: adapterremoval
Architecture: any
Depends: ${shlibs:Depends},
         ${misc:Depends}
Description: rapid adapter trimming, identification, and read merging of gene sequences
 This program searches for and removes remnant adapter sequences from High-
 Throughput Sequencing (HTS) data and (optionally) trims low quality
 bases from the 3' end of reads following adapter removal. AdapterRemoval
 can analyze both single end and paired end data, and can be used to
 merge overlapping paired-ended reads into (longer) consensus sequences.
 Additionally, the AdapterRemoval may be used to recover a consensus
 adapter sequence for paired-ended data, for which this information is
 not available.

Package: adapterremoval-examples
Architecture: all
Depends: ${misc:Depends}
Multi-Arch: foreign
Description: rapid adapter trimming, identification, and read merging (example data)
 This program searches for and removes remnant adapter sequences from High-
 Throughput Sequencing (HTS) data and (optionally) trims low quality
 bases from the 3' end of reads following adapter removal. AdapterRemoval
 can analyze both single end and paired end data, and can be used to
 merge overlapping paired-ended reads into (longer) consensus sequences.
 Additionally, the AdapterRemoval may be used to recover a consensus
 adapter sequence for paired-ended data, for which this information is
 not available.
 .
 This package provides the example data.

#Package: adapter-benchmark
#Architecture: all
#Depends: ${misc:Depends},
#         python3,
#         adapterremoval,
#         cutadapt,
#         ea-utils,
#         flexbar,
#         scythe,
#         trimmomatic
#Suggests: pirs
#Description: benchmarking trimming adapters gene sequences
# The program adapterremoval contains a benchmarking suite for differen
# programs fullfilling a similar purpose to searche for and remove
# remnant adapter sequences from High-Throughput Sequencing (HTS) data
# and trims low quality bases from the 3' end of reads following adapter
# removal.
# .
# This package provides the test suite adapted to the use with all
# Debian packaged programs which are: adapterremoval, cutadapt, flexbar,
# scythe and trimmomatic.

=== debian/watch ===
version=4

opts="filenamemangle=s%(?:.*?)?v?(\d[\d.]*)\.tar\.gz%@PACKAGE@-$1.tar.gz%" \
  https://github.com/MikkelSchubert/adapterremoval/tags (?:.*?/)?v?(\d[\d.]+)@ARCHIVE_EXT@

## adapterremoval 2.3.4

=== Makefile ===
--- 
+++ 
@@ -94,7 +94,7 @@
 DFILES   := $(OBJS:.o=.deps)
 
 
-.PHONY: all install clean test clean_tests static regression docs
+.PHONY: all install clean test clean_tests static regression docs examples
 
 all: build/$(PROG)
 
@@ -106,25 +106,30 @@
 	$(QUIET) rm -f build/$(PROG) build/$(LIBNAME).a
 	$(QUIET) rm -rvf build/regression
 	$(QUIET) rm -rvf $(BDIR)
+	$(QUIET) $(MAKE) -C examples clean
+
+examples: $(EXECUTABLE)
+	@echo $(COLOR_GREEN)"Running examples"$(COLOR_END)
+	$(QUIET) $(MAKE) -j1 -C examples EXE=$(shell realpath $(EXECUTABLE))
 
 # Install
 install: build/$(PROG)
 	@echo $(COLOR_GREEN)"Installing AdapterRemoval .."$(COLOR_END)
-	@echo $(COLOR_GREEN)"  .. binary into ${PREFIX}/bin/"$(COLOR_END)
-	$(QUIET) $(MKDIR) ${PREFIX}/bin/
-	$(QUIET) $(INSTALLEXE) build/$(PROG) ${PREFIX}/bin/
-
-	@echo $(COLOR_GREEN)"  .. man-page into ${PREFIX}/share/man/man1/"$(COLOR_END)
-	$(QUIET) $(MKDIR) ${PREFIX}/share/man/man1/
-	$(QUIET) $(INSTALLDOC) $(PROG).1 ${PREFIX}/share/man/man1/
-
-	@echo $(COLOR_GREEN)"  .. README into ${PREFIX}/share/adapterremoval/"$(COLOR_END)
-	$(QUIET) $(MKDIR) ${PREFIX}/share/adapterremoval/
-	$(QUIET) $(INSTALLDOC) README.md ${PREFIX}/share/adapterremoval/
-
-	@echo $(COLOR_GREEN)"  .. examples into ${PREFIX}/share/adapterremoval/examples/"$(COLOR_END)
-	$(QUIET) $(MKDIR) ${PREFIX}/share/adapterremoval/examples/
-	$(QUIET) $(INSTALLDAT) examples/*.* ${PREFIX}/share/adapterremoval/examples/
+	@echo $(COLOR_GREEN)"  .. binary into $(DESTDIR)${PREFIX}/bin/"$(COLOR_END)
+	$(QUIET) $(MKDIR) $(DESTDIR)${PREFIX}/bin/
+	$(QUIET) $(INSTALLEXE) build/$(PROG) $(DESTDIR)${PREFIX}/bin/
+
+	@echo $(COLOR_GREEN)"  .. man-page into $(DESTDIR)${PREFIX}/share/man/man1/"$(COLOR_END)
+	$(QUIET) $(MKDIR) $(DESTDIR)${PREFIX}/share/man/man1/
+	$(QUIET) $(INSTALLDOC) $(PROG).1 $(DESTDIR)${PREFIX}/share/man/man1/
+
+	@echo $(COLOR_GREEN)"  .. README into $(DESTDIR)${PREFIX}/share/adapterremoval/"$(COLOR_END)
+	$(QUIET) $(MKDIR) $(DESTDIR)${PREFIX}/share/adapterremoval/
+	$(QUIET) $(INSTALLDOC) README.md $(DESTDIR)${PREFIX}/share/adapterremoval/
+
+	@echo $(COLOR_GREEN)"  .. examples into $(DESTDIR)${PREFIX}/share/adapterremoval/examples/"$(COLOR_END)
+	$(QUIET) $(MKDIR) $(DESTDIR)${PREFIX}/share/adapterremoval/examples/
+	$(QUIET) $(INSTALLDAT) examples/*.* $(DESTDIR)${PREFIX}/share/adapterremoval/examples/
 
 static: build/$(LIBNAME).a

=== examples/Makefile ===
EXE := AdapterRemoval

TARGETS := single_end paired_end phred_64_encoded phred_33_encoded \
	collapsed_q50 multiple_adapters identify_adapters \
	interleaved_input interleaved_output interleaved_input_and_output \
	demultiplexing demultiplexing_only

.PHONY: all ${TARGETS} clean

all: ${TARGETS}

clean:
	rm -f output_*

single_end:
	$(EXE) --file1 reads_1.fq --basename output_single --trimns --trimqualities --gzip

paired_end:
	$(EXE) --file1 reads_1.fq --file2 reads_2.fq --basename output_paired --trimns --trimqualities --collapse

interleaved_input:
	$(EXE) --interleaved-input --file1 interleaved.fq --basename output_interleaved_input

interleaved_output:
	$(EXE) --interleaved-output --file1 reads_1.fq --file2 reads_2.fq --basename output_interleaved_output

interleaved_input_and_output:
	$(EXE) --interleaved --file1 interleaved.fq --basename output_interleaved_both

phred_64_encoded:
	$(EXE) --qualitybase 64 --file1 reads_q64.fq --basename output_phred_64

phred_33_encoded:
	AdapterRemoval --qualitybase 64 --qualitybase-output 33 --file1 reads_q64.fq --basename output_phred_33

collapsed_q50:
	$(EXE) --qualitymax 50 --file1 reads_1.fq --file2 reads_2.fq --collapse --basename output_collapsed_q50

multiple_adapters:
	$(EXE) --file1 reads_1.fq --file2 reads_2.fq --basename output_multi --trimns --trimqualities --collapse --adapter-list adapters.txt

identify_adapters:
	$(EXE) --identify-adapters --file1 reads_1.fq --file2 reads_2.fq

demultiplexing:
	$(EXE) --file1 demux_1.fq --file2 demux_2.fq --basename output_demux --barcode-list barcodes.txt

demultiplexing_only:
	$(EXE) --file1 demux_1.fq --file2 demux_2.fq --basename output_only_demux --barcode-list barcodes.txt --demultiplex-only

=== debian/changelog ===
adapterremoval (2.3.4-1) unstable; urgency=medium

  * Team upload.
  * New upstream version 2.3.4
  * d/control: declare compliance to standards version 4.7.2.
  * d/copyright: adjust Expat covered file name.
  * privacy-breaches.patch: new: prevent privacy breaches.

 -- Étienne Mollier <emollier@debian.org>  Sat, 01 Mar 2025 13:19:26 +0100

adapterremoval (2.3.3-3) unstable; urgency=medium

  * Team upload
  * Build-depend on discount instead of markdown (Closes: #1073089)
  * Standards-Version: 4.7.0 (routine-update)

 -- Charles Plessy <plessy@debian.org>  Thu, 13 Jun 2024 08:42:43 +0900

=== debian/control ===
--- 
+++ 
@@ -8,8 +8,8 @@
                zlib1g-dev,
                libbz2-dev,
                libgtest-dev,
-               markdown
-Standards-Version: 4.6.1
+               discount
+Standards-Version: 4.7.2
 Vcs-Browser: https://salsa.debian.org/med-team/adapterremoval
 Vcs-Git: https://salsa.debian.org/med-team/adapterremoval.git
 Homepage: https://github.com/MikkelSchubert/adapterremoval

=== debian/rules ===
#!/usr/bin/make -f

# DH_VERBOSE := 1

export DEB_BUILD_MAINT_OPTIONS = hardening=+all

include /usr/share/dpkg/default.mk

%:
	dh $@

override_dh_auto_build:
	dh_auto_build
	markdown README.md > README.html

override_dh_auto_test:
ifeq (,$(filter nocheck,$(DEB_BUILD_OPTIONS)))
	# dh_auto_test
	make test
	make clean_tests
endif

override_dh_auto_install:
	make PREFIX=$(CURDIR)/debian/$(DEB_SOURCE)/usr
	# Hmmm, this does nothing ...

override_dh_installchangelogs:
	dh_installchangelogs CHANGES.md

override_dh_fixperms:
	dh_fixperms
	find debian -name benchmark.sh -exec chmod +x \{\} \;
